import javax.microedition.lcdui.*;

public class AddBookmarkForm extends Form implements CommandListener { 
    ReaderCanvas canvas;
    BookmarkList list;
    TextField    name;

    AddBookmarkForm(ReaderCanvas canvas, BookmarkList list) { 
        super(Locale.NEW_BOOKMARK);
        this.canvas = canvas;
        this.list = list;
        addCommand(BookReader.ADD_CMD);
        addCommand(BookReader.BACK_CMD);
        name = new TextField(Locale.NAME, canvas.defaultBookmark, ReaderCanvas.MAX_BOOKMARK_LENGTH, TextField.ANY);
        append(name);
        setCommandListener(this);
        Display.getDisplay(canvas.reader).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == BookReader.ADD_CMD) { 
            String bookmarkName = name.getString().trim();
            if (bookmarkName.length() == 0) { 
                canvas.reader.error(Locale.EMPTY_NAME, this);
                return;
            }
            int pos = canvas.reader.addBookmark(new Bookmark(canvas.reader.currPagePos, bookmarkName));
            list.insert(pos, bookmarkName, null);
        }
        Display.getDisplay(canvas.reader).setCurrent(list);
    }
}


