import javax.microedition.lcdui.*;

public class EditBookmarkForm extends Form implements CommandListener { 
    ReaderCanvas canvas;
    BookmarkList list;
    int          index;
    TextField    name;
    Bookmark     bm;

    EditBookmarkForm(ReaderCanvas canvas, BookmarkList list, int index) { 
        super(Locale.EDIT_BOOKMARK);
        this.canvas = canvas;
        this.list = list;
        this.index = index;
        addCommand(BookReader.RENAME_CMD);
        addCommand(BookReader.BACK_CMD);
        bm = (Bookmark)canvas.reader.bookmarks.elementAt(index);
        name = new TextField(Locale.NAME, bm.name, ReaderCanvas.MAX_BOOKMARK_LENGTH, TextField.ANY);
        append(name);
        setCommandListener(this);
        Display.getDisplay(canvas.reader).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == BookReader.RENAME_CMD) { 
            String bookmarkName = name.getString().trim();
            if (bookmarkName.length() == 0) { 
                canvas.reader.error(Locale.EMPTY_NAME, this);
                return;
            }
            bm.name = bookmarkName;
            canvas.reader.updateBookmark(bm);
            list.set(index, bookmarkName, null);
        }
        Display.getDisplay(canvas.reader).setCurrent(list);
    }
}


