import javax.microedition.lcdui.*;

public class SearchForm extends Form implements CommandListener { 
    ReaderCanvas canvas;
    Displayable  parent;
    TextField    pattern;

    static final int MAX_SEARCH_PATTERN_LENGTH = 64;

    SearchForm(ReaderCanvas canvas, Displayable parent) { 
        super(Locale.SEARCH);
        this.canvas = canvas;
        this.parent = parent;
        addCommand(BookReader.SEARCH_CMD);
        addCommand(BookReader.BACK_CMD);
        pattern = new TextField(Locale.SEARCH, canvas.searchPattern, MAX_SEARCH_PATTERN_LENGTH, TextField.ANY);
        append(pattern);
        setCommandListener(this);
        Display.getDisplay(canvas.reader).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == BookReader.SEARCH_CMD) { 
            canvas.searchPattern = pattern.getString().trim();
            if (canvas.searchPattern.length() == 0) { 
                return;
            }
            canvas.searchPos = canvas.reader.search(0, canvas.searchPattern);
            if (canvas.searchPos < 0) { 
                canvas.reader.error(Locale.NOT_FOUND, this);
                return;
            }
            canvas.setPosition(canvas.searchPos);
            Display.getDisplay(canvas.reader).setCurrent(canvas);
            return;
        }
        Display.getDisplay(canvas.reader).setCurrent(parent);
    }
}


